> ## Documentation Index
> Fetch the complete documentation index at: https://www.c1.ai/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Update Credential

> UpdateCredential updates a client credential for a service principal.



## OpenAPI

````yaml https://spec.speakeasy.com/conductor-one/conductorone/my-source-with-code-samples patch /api/v1/service_principals/{service_principal_id}/credentials/{id}
openapi: 3.1.0
info:
  description: The C1 API is a HTTP API for managing C1 resources.
  title: C1 API
  version: 0.1.0-alpha
servers:
  - description: The C1 API server for the current tenant.
    url: https://{tenantDomain}.conductor.one
    variables:
      tenantDomain:
        default: example
        description: The domain of the tenant to use for this request.
security:
  - bearerAuth: []
    oauth: []
paths:
  /api/v1/service_principals/{service_principal_id}/credentials/{id}:
    patch:
      tags:
        - Service Principal
      summary: Update Credential
      description: UpdateCredential updates a client credential for a service principal.
      operationId: c1.api.service_principal.v1.ServicePrincipalService.UpdateCredential
      parameters:
        - in: path
          name: service_principal_id
          required: true
          schema:
            description: The service principal ID.
            readOnly: false
            type: string
        - in: path
          name: id
          required: true
          schema:
            description: The unique ID of the credential (cutename format).
            readOnly: true
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/c1.api.service_principal.v1.ServicePrincipalServiceUpdateCredentialRequestInput
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/c1.api.service_principal.v1.ServicePrincipalServiceUpdateCredentialResponse
          description: Successful response
      x-codeSamples:
        - lang: go
          label: UpdateCredential
          source: "package main\n\nimport(\n\t\"context\"\n\t\"github.com/conductorone/conductorone-sdk-go/pkg/models/shared\"\n\tconductoronesdkgo \"github.com/conductorone/conductorone-sdk-go\"\n\t\"github.com/conductorone/conductorone-sdk-go/pkg/models/operations\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := conductoronesdkgo.New(\n        conductoronesdkgo.WithSecurity(shared.Security{\n            BearerAuth: \"<YOUR_BEARER_TOKEN_HERE>\",\n            Oauth: \"<YOUR_OAUTH_HERE>\",\n        }),\n    )\n\n    res, err := s.Principal.UpdateCredential(ctx, operations.C1APIServicePrincipalV1ServicePrincipalServiceUpdateCredentialRequest{\n        ID: \"<id>\",\n        ServicePrincipalID: \"<id>\",\n    })\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.ServicePrincipalServiceUpdateCredentialResponse != nil {\n        // handle response\n    }\n}"
        - lang: typescript
          label: Typescript (SDK)
          source: >-
            import { ConductoroneSDKTypescript } from
            "conductorone-sdk-typescript";


            const conductoroneSDKTypescript = new ConductoroneSDKTypescript({
              security: {
                bearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
                oauth: "<YOUR_OAUTH_HERE>",
              },
            });


            async function run() {
              const result = await conductoroneSDKTypescript.principal.updateCredential({
                servicePrincipalId: "<id>",
                id: "<id>",
              });

              console.log(result);
            }


            run();
components:
  schemas:
    c1.api.service_principal.v1.ServicePrincipalServiceUpdateCredentialRequestInput:
      description: The ServicePrincipalServiceUpdateCredentialRequest message.
      properties:
        credential:
          $ref: >-
            #/components/schemas/c1.api.service_principal.v1.ServicePrincipalCredential
        updateMask:
          nullable: true
          readOnly: false
          type: string
      title: Service Principal Service Update Credential Request
      type: object
      x-speakeasy-name-override: ServicePrincipalServiceUpdateCredentialRequest
    c1.api.service_principal.v1.ServicePrincipalServiceUpdateCredentialResponse:
      description: The ServicePrincipalServiceUpdateCredentialResponse message.
      properties:
        credential:
          $ref: >-
            #/components/schemas/c1.api.service_principal.v1.ServicePrincipalCredential
      title: Service Principal Service Update Credential Response
      type: object
      x-speakeasy-name-override: ServicePrincipalServiceUpdateCredentialResponse
    c1.api.service_principal.v1.ServicePrincipalCredential:
      description: >-
        ServicePrincipalCredential represents a client credential for a service
        principal.
      properties:
        allowSourceCidrs:
          description: CIDR restrictions for this credential.
          items:
            type: string
          nullable: true
          readOnly: true
          type: array
        clientId:
          description: >-
            The full client ID in format:
            ${cutename}@${tenant}.${installation}/spc
          readOnly: true
          type: string
        createdAt:
          format: date-time
          readOnly: true
          type: string
        displayName:
          description: The display name of the credential.
          readOnly: false
          type: string
        expiresAt:
          format: date-time
          readOnly: true
          type: string
        id:
          description: The unique ID of the credential (cutename format).
          readOnly: true
          type: string
        lastUsedAt:
          format: date-time
          readOnly: true
          type: string
        requireDpop:
          description: Whether DPoP proof-of-possession is required for this credential.
          readOnly: true
          type: boolean
        scopedRoleIds:
          description: >-
            Scoped role IDs for this credential (intersection with SP roles at
            token issuance).
          items:
            type: string
          nullable: true
          readOnly: true
          type: array
        servicePrincipalId:
          description: The service principal user ID this credential belongs to.
          readOnly: true
          type: string
      title: Service Principal Credential
      type: object
      x-speakeasy-name-override: ServicePrincipalCredential
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http
    oauth:
      description: >-
        This API uses OAuth2 with the Client Credential flow.

        Client Credentials must be sent in the BODY, not the headers.

        For an example of how to implement this, refer to the
        [c1TokenSource.Token()](https://github.com/ConductorOne/conductorone-sdk-go/blob/3375fe7c0126d17e7ec4e711693dee7b791023aa/token_source.go#L101-L187)
        function.
      flows:
        clientCredentials:
          scopes: {}
          tokenUrl: /auth/v1/token
      type: oauth2

````